Source10: kmodtool
%define   kmodtool bash %{SOURCE10}

# if kversion isn't defined on rpm build line, build against current kernel
%{!?kversion: %define kversion %(uname -r)}

# hint: this can he overridden with "--define kversion foo" on the rpmbuild command line, e.g.
# --define "kversion 2.6.18-8.el5"

%define kmod_name r1000
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

%define upvar ""

%ifarch i686 x86_64 ia64
%define xenvar xen
%endif

%ifarch i686
%define paevar PAE
%endif

%ifarch ppc64 ppc64iseries
%define kdumpvar kdump
%endif

%ifarch sparc64 ppc
%define smpvar smp
%endif

%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?paevar} %{?kdumpvar}}

# hint: this can he overridden with "--define kvariants foo bar" on the rpmbuild command line, e.g.
# --define 'kvariants "" smp'

Name:		%{kmod_name}-kmod
Version:	1.05
Release:	3.%(echo %{kverrel} | tr - _)
Summary:	Realtek RTL8169S/SB/SC, RTL8168B, RTL8101E driver 

License:	GPLv2
Group:		System Environment/Kernel

Source0:	ftp://202.65.194.211/cn/nic/r1000_v1.05.tgz
Source1:	COPYING

Patch0:		kmod_r1000_el5.patch

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
ExclusiveArch:	i686 x86_64 ppc64 ia64 sparc64 ppc
Provides:	%{name}-common = %{version}-%{release}


%description 
RealTek Ethernet drivers, which are listed as following.

1. RTL8169S/SB/SC (Gigabit Ethernet with PCI interface).
2. RTL8168B (Gigabit Ethernet with PCI-Express interface).
3. RTL8101E (Fast Ethernet with PCI-Express interface).

%package common

Summary:        Common files for the r1000 kernel module
Group:          System Environment/Kernel

%description common
Documentation for RealTek Ethernet drivers

# magic hidden here:
# NOTE: these two extra defines will not be necessary in future.
%{expand:%(%{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
%setup -q -c -T -a 0
%patch -p0

for kvariant in %{kvariants} ; do
    cp -a r1000_v1.05 _kmod_build_$kvariant
done

 
%build

for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    make -C "${ksrc}" modules M=$PWD/src
    popd
done


%install

mkdir -p %{buildroot}%{_datadir}/doc/%{kmod_name}-%{version}
install -m644 %{SOURCE1} %{buildroot}%{_datadir}/doc/%{kmod_name}-%{version}
install -m644 r1000_v1.05/README %{buildroot}%{_datadir}/doc/%{kmod_name}-%{version}
install -m644 r1000_v1.05/release_note.txt %{buildroot}%{_datadir}/doc/%{kmod_name}-%{version}


for kvariant in %{kvariants}
do
    ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
    pushd _kmod_build_$kvariant
    make -C "${ksrc}" INSTALL_MOD_PATH=$RPM_BUILD_ROOT INSTALL_MOD_DIR=extra/%{kmod_name} modules_install M=$PWD/src
    popd
done



%clean
rm -rf $RPM_BUILD_ROOT

%files common
%dir %{_datadir}/doc/%{kmod_name}-%{version}/*

%changelog
* Mon Apr 30 2007 LandShark BuildSys <BuildSys[AT]LandShark.Net>
- Linux device driver released for RealTek Ethernet controllers, which are listed as following.
   1. RTL8169S/SB/SC (Gigabit Ethernet with PCI interface)
   2. RTL8168B (Gigabit Ethernet with PCI-Express interface)
   3. RTL8101E (Fast Ethernet with PCI-Express interface)
   4. RTL8110

